/*
 *
 *  kryptomedia- Another KDE cryto media application.
 *
 *  Copyright (C) 2006  Daniel Gollub <dgollub@suse.de>
 *
 *
 *  This file is part of kryptomedia.
 *
 *  kbluetooth is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  libkbluetooth is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with libkbluetooth; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

#ifndef KRYPTOMEDIA_H_
#define KRYPTOMEDIA_H_

#include <kapp.h>
#include <kcmdlineargs.h>
#include <kmessagebox.h>
#include <klocale.h>
#include <kconfig.h>
#include <kdebug.h>
#include <qvaluevector.h>

#include <dbus/dbus.h>
#include <dbus/connection.h>
#include <hal/libhal.h>

#include "dialog.h"
#include "kryptomediadevice.h"

class Dialog;

class KryptoMedia : public QWidget
{

Q_OBJECT	

public:
        KryptoMedia(const QString &udi);
        ~KryptoMedia();
	 	QStringList getDevicesNeedDecrypt();

public slots:
	void slotSendPassword();
	void slotCancel();
	void setNewUDI(QString&);


signals:
	void signalPasswordError(QString errorName, QString errorMsg);
	void signalDecrypted();

private:

	bool initDBus();
	void deinitDBus();
	bool initHAL();
	bool deinitHAL();

	static void encryptCallback(DBusPendingCall* pcall, void* /*data*/);
	QString getHalPropertyString(QString udi, QString value);

	Dialog *dialog;

	DBusConnection *mDBusConnection;
	DBusQt::Connection *mDBusQtConnection;
	LibHalContext *mHALctx;
	QString mUDI;
	QString mUDIparent;
	QString mVendor;
	QString mProduct;
	QString mDeviceNode;
	QString mDeviceType;
	void initUi(QStringList&);
	QValueVector<KryptoMediaDevice*> *devices;

	static KryptoMedia *_ctx;

};

#endif // KRYPTOMEDIA_H_

